#
# Sample Apache imitation server for Impost
# This is just an example, you can modify it to work however
# you want it to.
#
# Maybe you could use it to mimic a known vulnerable HTTPD
# b4 pissing off a script kiddie that may have 0day for it?
#

use File::stat;

$server = "Apache/1.3.29 (Unix) mod_perl/1.29 PHP/4.3.6";
$server_name = "Apache/1.3.29 (Unix)";
$last_modified = "Wed, 14 Jul 2004 22:49:32 GMT";
$html_file = "/tmp/fake.html";
$hostname = "localhost";

# INFO ON ABOVE VARIABLES
# $server, $last_modified, and $hostname are all variables
# which will replace identifiers in the server responses
# (right before it displays content).
#
# $html_file will be displayed when / is requested
#
# $server_name and $hostname will replace 2 identifers
# in both BAD REQUEST and NOT FOUND (look near end of this file)

sub on_server_accept
{
	# We need client input!
	# Return without doing anything
	return;
}

# Clean up the variables
# especially $request_type so it doesn't automatically assume a GET 
# request in the future

sub end_connection
{
	$close_connection = 1;
	$file_request = "";
	$request_type = "";
	return;
}

# The brains of this operation
# This function alone will handle pretty much everything

sub on_server_read
{
	my($req, $arg, $other) = split(/\ /,$_[0],3);
	my($date_syntax) = `date +\"%a, %d %b %Y %H:%M:%S %Z\"`;
	my($file_stat, $file_size);

	chop($date_syntax);	# remove new-line

	# Check for GET request
	# if so, allocate request type and file requested
	if ($req eq "GET") {
		$file_request = $arg;
		$request_type = $other;
		return;
	}

	# If we got an empty line sent our way, we're probably
	# expected to send the goods
	if ((!$req) && ($request_type))
	{
		# check to see if the request is bad
		if (($request_type ne "HTTP/1.0") &&
			($request_type ne "HTTP/1.1")) {
			@temp_data = split(/\n/, $bad_request);

			# you'll see similar code 2 more times
			# it replaces all the identifiers
			foreach $line (@temp_data) {
				$line =~ s/\[DATE\]/$date_syntax/i;
				$line =~ s/\[SERVER\]/$server/i;
				$line =~ s/\[SERVERNAME\]/$server_name/i;
				$line =~ s/\[HOSTNAME\]/$hostname/i;
				@reply_data = (@reply_data, "$line\n");
			}
			end_connection;
			return;
		}

		# we'll only spill $html_file upon requesting /
		# otherwise send the client $not_found
		#
		# you could setup a HASH table and have a whole
		# wack of files and valid requests if you wanna
		# do a little scripting
		if ($file_request eq "/") {
			$file_stat = stat($html_file);
			$file_size = $file_stat->size;
			open(FILE, "< $html_file");
			@temp_data = split(/\n/, $http_ok);
                        foreach $line (@temp_data) {
                                $line =~ s/\[DATE\]/$date_syntax/i;
                                $line =~ s/\[SERVER\]/$server/i;
                                $line =~ s/\[SIZE\]/$file_size/i;
				$line =~ s/\[SERVERNAME\]/$server_name/i;
				$line =~ s/\[MODIFIED\]/$last_modified/i;
				@reply_data = (@reply_data, "$line\n");
                        }
			@reply_data = (@reply_data, "\n", <FILE>);
			close(FILE);
		} else {
			@temp_data = split(/\n/, $not_found);
			foreach $line (@temp_data) {
				$line =~ s/\[GETREQUEST\]/$file_request/i;
				$line =~ s/\[DATE\]/$date_syntax/i;
				$line =~ s/\[SERVER\]/$server/i;
				$line =~ s/\[HOSTNAME\]/$hostname/i;
				$line =~ s/\[SERVERNAME\]/$server_name/i;
				@reply_data = (@reply_data, "$line\n");
			}
		}

		end_connection;
		return;
	}
	return;
}

$http_ok = qq{HTTP/1.1 200 OK
Date: [DATE]
Server: [SERVERNAME]
Last-Modified: [MODIFIED]
ETag: "2bc67-89d-40f5b87c"
Accept-Ranges: bytes
Content-Length: [SIZE]
Connection: close
Content-type: text/html

};

$bad_request = qq{HTTP/1.1 400 Bad Request
Date: [DATE]
Server: [SERVERNAME]
Connection: close       
Transfer-Encoding: chunked
Content-Type: text/html; charset=iso-8859-1

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<title>400 Bad Request</title>
</head><body>
<h1>Bad Request</h1>
<p>Your browser sent a request that this server could not understand.<br>
</p>
<hr>                  
<address>[SERVERNAME] Server at [HOSTNAME] Port 80</address>
</body></html>
};                      

$not_found = qq{HTTP/1.1 404 Not Found
Date: [DATE]     
Server: [SERVERNAME]
Connection: close
Content-Type: text/html; charset=iso=8859-1

<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html><head>
<title>404 Not Found</title>
</head><body>
<h1>Not Found</h1>
<p>The requested URL [GETREQUEST] was not found on this server.</p>
<hr>
<address>[SERVERNAME] Server at [HOSTNAME] Port 80</address>
</body></html>
};

# EOF
