# Here's an example of scripting for Impost
# ziplock (sickbeatz@hotmail.com)
#
# Read the comments, and if you can get the jist of basic Perl you'll
# be able to setup your traps or analyze networks a whole lot easier
# than before.

# These variables will stay with us until Impost is actually shutdown
# You can define anything you want here or print something to STDOUT
# that will be displayed when Impost starts up.

$username = "test";
$password = "word";
$message  = "w00t! It FUCKING works";

# You can have as many sub routines as you please, however when you
# write a script for Impost, you MUST include these 2 sub routines
# you see here in this script: "on_server_accept" and "on_server_read"
# This sub routine is called everytime a new connection is established

sub on_server_accept
{
	# In this routine the first argument (argument #0) will always
	# contain the source I.P. of the connecting client. The second
	# argument will always contain the file descriptor the socket
	# is connected to.

	# The script does not make send() calls directly, instead it
	# creates an ARRAY which will be recognized by Impost upon
	# return. Impost will then split up the array sending out
	# each string to the client machine.

	@welcome_message = ("Welcome, this is a bullshit service :P\n",
		"You're connecting from $_[0], great!\n");
}

# Everytime Impost reads something from a client socket, it calls up
# this function. Argument #0 is a string of parameters, and argument
# #1 is the socket descriptor.

sub on_server_read
{
	my($arg1, $arg2, $remainder) = split(/\ /, $_[0], 3);
	my($fd) = $_[1];

	# NOTE: Same concept as on_server_accept for sending messages
	# back to the client socket, however the array is labelled
	# @reply_data instead of @welcome_message

	if ($arg1 eq "LOGIN") {
		if ($login_attempt[$fd]) {

			# @login_attempt is a script-side variable
			# that will let me determine if a client has
			# already begun logging in.

			@reply_data = ("Password required for $arg2\n");
			return;
		}

		# if $arg2 matches $username in which I defined at the
		# beginning of the script, acknowledge that and
		# ask for a password

		if ($arg2 eq $username) {
			@reply_data = ("User recognized.\n",
				"Please enter password for $arg2.\n");

			# Now I'm going to add the clients username
			# to the @login_attempt ARRAY. I'm also
			# going to use the socket fd that they're
			# connected to so I don't get them mixed up
			# with other connections.

			$login_attempt[$fd] = $arg2;
			return;
		} else
		{
			@reply_data = ("Invalid username.\n");

			# To close a connection via the script, you
			# have to set the variable $close_connection
			# to '1' and Impost will automatically pick
			# that up.

			$close_connection = 1;
			return;
		}
	}

	# Okay, now that we have the username in order,
	# we need the password.

	if ($arg1 eq "PASS") {
		if (!$login_attempt[$fd]) {

			# Check the @login_attempt ARRAY to see if
			# this client has entered a recognized
			# username, if not send them back to Impost
			# and let them try again.

			@reply_data = ("Please supply a username.\n");
			return;
		}
		if ($arg2 eq $password) {
			
			# Okay, password accepted. Send our little
			# secret $message in the reply, remove them
			# from the @login_attempt ARRAY and close
			# the connection, we're done.

			@reply_data = ("Password accepted.\n",
				"Secret Message: $message\n");
			$login_attempt[$fd] = "";
			$close_connection = 1;
			return;
		} else {

			# Wrong password. Fuck it
			# let him keep trying :) This script's only
			# to give you a small idea of how scripting
			# is done with Impost. It's pretty basic
			# so have fun

			@reply_data = ("Wrong password.\n");
			return;
		}
	}
	
}

# EOF
