/*
 * impost.c - main driver file for Impost
 * 
 * Written by ziplock
 * 
 * Comments: sickbeatz@hotmail.com IRC: #b4b0 on EFNet
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59
 * Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "impost.h"
#include "messages.h"

/*
 * If the `NOP padding' is TRUE byte repeating, define the character data in
 * `Detected_NOP_chr'.
 */
impost_boolean  Detected_NOP_chr = FALSE;

/* If nonzero, buffer contains known opcode instructions.  */
impost_boolean  Has_Opcode_Instructions = FALSE;

/* X86 `NOP padding/sled' information.  */
x86_nop_data    x86_sled_pattern[512];
x86_nop_data    Detected_sled_Type[100];

nop_info        x86_sled_pattern_size = 0, SLT = 0;
nop_info        x86_nop_start = 0;
nop_info        x86_sled_len = 0, x86_sled_t = 0;

impost_boolean  has_sparc_nops = FALSE;
nop_info        sparc_nop_start = 0;

/* Display checking messages always.  */
impost_boolean  checking_messages = FALSE;

/* Socket information.  */
static fd_set   Socket_List;

static int      Local_sock;
static int      Highest_Socket;
static int      Connections[5];

/* Global configuration switches.  */
impost_boolean  Raw_mode = FALSE;
impost_boolean  Use_Script = FALSE;
impost_boolean  Buffer_Repeats = FALSE;
impost_boolean  Display_conf_setup = FALSE;
impost_boolean  disable_capture = FALSE;

/* X86 type `NOP' code instruction list.  */
const char      x86_nop_list[] =
{
	0x27, 0x2f, 0x33, 0x37, 0x3f, 0x40, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46,
	0x47, 0x48, 0x49, 0x4a, 0x4b, 0x4c, 0x4d, 0x4e, 0x4f, 0x50, 0x51, 0x52,
	0x53, 0x54, 0x55, 0x56, 0x57, 0x58, 0x5a, 0x5b, 0x5c, 0x5d, 0x5e, 0x5f,
	0x60, 0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99, 0x9a,
	0x9b, 0x9c, 0x9d, 0x9e, 0x9f, 0xf5, 0xf7, 0xf8, 0xf9, 0xfc
};

/* SPARC type `NOP' code instruction list.  */
unsigned long   sparc_nops[16] =
{
	0x20bfbf00, 0x801bc00f, 0x89a50822, 0x983e8012, 0xa2034012,
	0xa20e8013, 0xa21a400a, 0xa21c8012, 0xa4274012, 0xa61cc013,
	0xac15a16e, 0xb2268019, 0xb606401a, 0xfffffff8, 0xfffffff8
};

/*
 * User history; contains real-time log of received data during client/server
 * communication.
 */
struct user_h
{
	char            Received_History[256][25];
	int             Hist_count;
};
struct user_h   User_Info[5];

/* Set configuration settings.  */
struct config_options config_opt[] =
{
	{"MESSAGE_TRIGGER_SIZE", DEFAULT_TRIGGER_SIZE, 0},

	{"ENABLE_LOGGING", DEFAULT_ENABLE_LOGGING, 0},
	{"LOGFILE", 0, DEFAULT_LOGFILE},

	{"MAX_READ_SIZE", DEFAULT_READ_SIZE, 0},

	{"CAPTURE_DIRECTORY", 0, DEFAULT_CAPTURE_DIRECTORY},

	{"SHELLCODE_DEFINITIONS", 0, DEFAULT_DEFINITIONS}
};

/* External configuration settings.  */
extern int      Server_port;

extern impost_boolean Disable_hexdump;

extern char    *Script_File;

/* Packet history from packets.c.  */
#ifdef HAVE_LIBPCAP
extern struct packet_h Packet_History[5];
#endif				/* HAVE_LIBPCAP */

static char     Client_ip[16][5];

/*
 * Guess return address by going backwards starting at the end of 'buf' --
 * Ignore no-operations. Return the address on success or -1 on error.
 */
unsigned long
Find_Reversed_x86_Address(buf)
	char           *buf;
{
	nop_t           hex;
	int             i, x, a = 0;

	char            nop_pad[] = "90909090";

	char           *c_str = (char *)malloc(16);
	char           *n_str = (char *)malloc(16);

#ifdef DEBUG
	printf("DB Scanning buffer for Reversed x86 address..\n");
#endif				/* DEBUG */

	i = strlen(buf);

	while (i > FALSE)
	{
		memset(c_str, 0, 16);
		memset(n_str, 0, 16);

		hex = (nop_t) buf[i] & 0xff;
		do
		{
			--i;
			hex = (nop_t) buf[i] & 0xff;
			a = i;
		}
		while ((hex == Detected_NOP_chr) || (buf[i] == 0x00));

		x = i - 4;

		sprintf(n_str, "%x%x%x%x",
			(int)buf[x] & 0xff, (int)buf[x - 1] & 0xff,
			(int)buf[x - 2] & 0xff, (int)buf[x - 3] & 0xff);

		sprintf(c_str, "%x%x%x%x",
			(int)buf[i] & 0xff, (int)buf[i - 1] & 0xff,
			(int)buf[i - 2] & 0xff, (int)buf[i - 3] & 0xff);

		if ((i > (strlen(buf) - 4)) && (a == i))
			return strtoul(c_str, NULL, 16);

		if (i < strlen(buf))
		{
#ifdef DEBUG
			printf("db: c_str = %s\n", c_str);
			printf("db: n_str = %s\n", n_str);
#endif
			if (!strcmp(c_str, n_str) && strcmp(c_str, nop_pad))
			{
#ifdef DEBUG
				printf("db:MATCH: 0x%s...\n", c_str);
#endif
				return strtoul(c_str, NULL, 16);
			}
		}
		i--;
	}

	return -1;
}

/*
 * Perform capture; Log all history data to a newly created file containing
 * suspicious buffer and received data leading to that buffer.
 */
int
Impost_Capture(buffer, c, Impost_Mode, ipaddr)
	char           *buffer;
	int             c, Impost_Mode;
	char           *ipaddr;
{
	FILE           *tmp_file;
	char           *capture_filename = (char *)malloc(FILENAME_MAX);
	char           *capture_filename_tmp = (char *)malloc(FILENAME_MAX);
	int             i, hex, ln = 0;
	struct tm      *timeptr;
	time_t          tm;

	tm = time(NULL);
	timeptr = localtime(&tm);
	strftime(capture_filename_tmp, 14, "%m%y-%H-%M-%S", timeptr);
	sprintf(capture_filename, "%s/capture-%s", config_opt[4].option,
		capture_filename_tmp);

	Impost_PutsF(0, IMPOST_CAPTURE_FILE, capture_filename);

	tmp_file = fopen(capture_filename, "a+");
	if (!tmp_file)
	{
		perror("fopen()");
		return -1;
	}
	fprintf(tmp_file, "%s Impost capture file, source IP address: %s\n",
		Impost_Get_TimeStamp(), ipaddr);
	fprintf(tmp_file,
		"History of received data pertaining to this session:\n");

	if (Impost_Mode == SERVER_CAPTURE)
	{
		for (i = 0; i < User_Info[c].Hist_count; i++)
			fprintf(tmp_file, "%2d (%d bytes) = %s\n", i + 1,
				strlen(User_Info[c].Received_History[i]),
				User_Info[c].Received_History[i]);
	}
#ifdef HAVE_LIBPCAP
	if (Impost_Mode == PACKET_CAPTURE)
	{
		for (i = 0; i < Packet_History[c].Count; i++)
			fprintf(tmp_file, "%2d (%d bytes) = %s\n", i + 1,
				strlen(Packet_History[c].Data_Segment[i]),
				Packet_History[c].Data_Segment[i]);
	}
#endif				/* HAVE_LIBPCAP */

	if (Raw_mode == TRUE)
	{
		fprintf(tmp_file, "\nSuspicious buffer (raw data)\n");
		fprintf(tmp_file, "%s", buffer);

		fclose(tmp_file);
		return 0;
	}
	fprintf(tmp_file, "\nSuspicious buffer (C constant string)\n\n");
	fprintf(tmp_file, "const char buffer[] = { ");

	for (i = 0; i < strlen(buffer); i++)
	{
		ln++;
		hex = (int)(buffer[i] & 0xff);

		if ((ln == 12) || (i == 9))
		{
			fprintf(tmp_file, "\n  0x%.2x, ", hex);
			ln = 0;

			continue;
		}
		if (i != (strlen(buffer) - 1))
			fprintf(tmp_file, "0x%.2x, ", hex);
		else
			fprintf(tmp_file, "0x%.2x };\n", hex);
	}

	fclose(tmp_file);

	return 0;
}

/*
 * Delete history data belonging to the connection that was just killed.
 */
int
clear_Received_History(sel)
	int             sel;
{
	int             i;

	for (i = 0; i < 25; i++)
		*User_Info[sel].Received_History[i] = 0;
	User_Info[sel].Hist_count = 0;

	return 0;
}

/* Process format to output and whatever else.  */
int
Impost_PutsF(int ipf_type, char *format,...)
{
	char           *output = (char *)malloc(256);
	va_list         args;

	memset(output, 0, sizeof(output));

	va_start(args, format);
	vsprintf(output, format, args);
	va_end(args);

	if (config_opt[1].value == TRUE)
	{
		switch (ipf_type)
		{
		case 0:
			write_log("%s %s",
				  Impost_Get_TimeStamp(), output);
			break;
		case 1:
			write_log("%s", output);
			break;
		default:
			break;
		}
	}
	printf("%s", output);

	return 0;
}

/* Convert the integer 'c' and return it in a String.  */
char           *
ItoS(c)
	int             c;
{
	char           *ret = (char *)malloc(2);

	if (!c)
		return NULL;
	sprintf(ret, "%c", c);
	return ret;
}

/*
 * Verify that the variable 'c' contains a valid x86 no-operation code. One
 * is yes; zero is no.
 */
int
x86_Verify_NOP(c)
	nop_t           c;
{
	int             i;

	for (i = 0; i < strlen(x86_nop_list); i++)
	{
		if (c == (nop_t) x86_nop_list[i])
			return 1;
	}

	return 0;
}

/*
 * Find the length of a x86 NOP sled so we can find out more important
 * values.
 */
int
x86_sled(buffer)
	char           *buffer;
{
	char            test_str[3];
	int             i, x;

	for (i = 0; i < strlen(buffer); i++)
	{
		if (!x86_Verify_NOP(buffer[i]))
			return i;

		memset(test_str, 0, 3);

		test_str[0] = buffer[i];
		test_str[1] = buffer[i + 1];

		for (x = 0; x < X86_OPCODES; x++)
		{
			if (!strncmp(x86_common[x].operation_code, test_str, 2))
				return i;
		}
	}
	return i;
}

/*
 * Determine type of NOP sled in buffer. Return X86_SLED_SINGLE,
 * X86_SLED_PATTERN or X86_SLED_RANDOM.
 */
int
x86_sled_Type(buffer, sled_len)
	char           *buffer;
	int             sled_len;
{
	char            chunk1[sled_len + 1], chunk2[sled_len + 1];
	int             byte, cs, cp;
	int             i = 0, x = 0, ct = 0, found_p = 0, ms = 0;

	byte = buffer[0];

	if ((buffer[sled_len - (sled_len / 2)] == byte) &&
	    (buffer[sled_len - (sled_len - 10)] == byte) &&
	    (buffer[5] == byte))
		return X86_SLED_SINGLE;

	memset(x86_sled_pattern, 0, 512);

	for (cs = 2; cs < sled_len; cs++)
	{
		i = 0;
		do
		{
			memset(chunk1, 0, sled_len + 1);
			memset(chunk2, 0, sled_len + 1);

			for (cp = 0; cp < cs; cp++)
			{
				chunk1[cp] = buffer[i + cp];
				chunk2[cp] = buffer[i + cp + cs];
			}

			if (!strcmp(chunk1, chunk2))
			{
#ifdef DEBUG
				printf("db: '%s' (sp=%d) matches '%s' (sp=%d)\n",
				       chunk1, i + cp, chunk2, i + cp + cs);
				printf("db:Discovered %d byte pattern\n", cs);
#endif				/* DEBUG */

				x86_sled_pattern_size = cs;

				memset(x86_sled_pattern, 0, 512);
				if (x86_sled_pattern_size > 256)
					ms = 256;
				else
					ms = x86_sled_pattern_size;
				for (x = 0; x < ms; x++)
					sprintf(x86_sled_pattern, "%s\\x%x",
						x86_sled_pattern, chunk1[x]);

				found_p = TRUE;

				if (cs > 3)
					return X86_SLED_PATTERN;
			}
			if ((i + cs) < sled_len)
				i += cs;
			else
				break;
		}
		while (i < sled_len);
	}

	if (found_p)
		return X86_SLED_PATTERN;

	return X86_SLED_RANDOM;
}

/*
 * Locate SPARC `NOP' codes, return zero if not found or return 1 and set
 * `sparc_nop_start' to position of first code.
 */
int
Locate_SPARC_Nops(buffer)
	char           *buffer;
{
	int             i, x;
	char            chunk[4], chunk1[4], c_chunk1[8], c_chunk2[8];

	for (x = 0; x < strlen(buffer); x += 4)
	{
		memset(chunk, 0, 4);

		chunk1[0] = buffer[x] & 0xff;
		chunk1[1] = buffer[x + 1] & 0xff;
		chunk1[2] = buffer[x + 2] & 0xff;
		chunk1[3] = buffer[x + 3] & 0xff;

		for (i = 0; i < 14; i++)
		{
			memset(c_chunk1, 0, 8);
			memset(c_chunk2, 0, 8);
			memset(chunk, 0, 4);

			chunk[0] = (sparc_nops[i] >> 24) & 0xff;
			chunk[1] = (sparc_nops[i] >> 16) & 0xff;
			chunk[2] = (sparc_nops[i] >> 8) & 0xff;
			chunk[3] = (sparc_nops[i] >> 0) & 0xff;

			sprintf(c_chunk1, "%x%x%x%x",
				chunk[0] & 0xff, chunk[1] & 0xff,
				chunk[2] & 0xff, chunk[3] & 0xff);
			sprintf(c_chunk2, "%x%x%x%x",
				chunk1[0] & 0xff, chunk1[1] & 0xff,
				chunk1[2] & 0xff, chunk1[3] & 0xff);

			if (!strcmp(c_chunk1, c_chunk2))
			{
				sparc_nop_start = x;
				if (strlen(buffer) > config_opt[0].value || checking_messages)
					Impost_PutsF(0, CHECKING_FOUND);
				Impost_PutsF(0, SP_SPARC_NOP_FIND,
					   chunk[0] & 0xff, chunk[1] & 0xff,
					  chunk[2] & 0xff, chunk[3] & 0xff);
				return 1;
			}
		}
	}

	return 0;
}

/*
 * Print a table of hexidecimals for buffers that contain non-printable
 * characters -- display '.' as non-printable characters in the ascii column
 * instead of the non-printable character.
 */
int
Impost_Hexdump(buffer, selected)
	char           *buffer;
	int             selected;
{
	char           *HexOut = (char *)malloc(256);
	char           *AscOut = (char *)malloc(256);
	char           *Last_Buffer = (char *)malloc(256);

	int             lpos, i, x;
	nop_t           hex;

	if (Disable_hexdump)
		return FALSE;

	if (HexOut == FALSE || Last_Buffer == FALSE || AscOut == FALSE)
	{
		Impost_PutsF(0, ERROR_MALLOC);
		exit(1);
	}
	memset(HexOut, 0, 256);
	memset(AscOut, 0, 256);

	for (i = 0, lpos = 0; i < strlen(buffer) + 1; i++)
	{
		hex = buffer[i] & 0xff;
		if (lpos == 15)
		{
			if (strcmp(Last_Buffer, HexOut))
			{
				if (Buffer_Repeats > FALSE)
				{
					printf(IMPOST_HEXDUMP_REPEAT,
					       Connections[selected], Buffer_Repeats);

					Buffer_Repeats = 0;
				}
				strcpy(Last_Buffer, HexOut);

				printf(IMPOST_HEXDUMP3,
				       Connections[selected], HexOut,
				       AscOut);
			} else
			{
				Buffer_Repeats++;
			}

			sprintf(AscOut, "%s",
				isprint(buffer[i]) ? ItoS(buffer[i]) : ".");
			sprintf(HexOut, "%.2X ", hex);

			lpos = 1;
			continue;
		}
		if (lpos < 15 && i == strlen(buffer))
		{
			printf(IMPOST_HEXDUMP1, Connections[selected],
			       HexOut);

			for (x = 0; x < ((15 - lpos) * 3); x++)
				printf(" ");

			printf(IMPOST_HEXDUMP2, AscOut);
			break;
		}
		sprintf(AscOut, "%s%s", AscOut,
			isprint(buffer[i]) ? ItoS(buffer[i]) : ".");
		sprintf(HexOut, "%s%.2X ", HexOut, hex);

		lpos++;
	}

	return 0;
}

/*
 * This function gets called everytime a suspicious buffer is detected, We'll
 * try and analyze the data as much as we can.
 */
int
Detected_Buffer(buffer, length, nops, nop_start, selected, f_Instruct)
	char           *buffer;
	int             length;
	int             nops;
	int             nop_start;
	int             selected;
	int             f_Instruct;
{
	nop_t           cur_Nop, x86_sled_len = nops, sled_len = 0;
	int             SCinfo;
	unsigned long   x86_return_address;

	Impost_PutsF(0, SP_DETECT, length);

	if (strlen(Detected_sled_Type) > TRUE)
		Impost_PutsF(0, SP_SLED_TYPE, Detected_sled_Type);

	sled_len = nops;

	if (Detected_NOP_chr && SLT == TRUE)
	{
		cur_Nop = (nop_t) Detected_NOP_chr & 0xff;
		if (x86_sled_len > 10)
		{
			if (cur_Nop == 0x90)
			{
				Impost_PutsF(0, SP_X86_NOP_COUNT, x86_sled_len);
			} else
			{
				Impost_PutsF(0, SP_OTHER_CHAR_NOP,
					     cur_Nop, cur_Nop, x86_sled_len);
			}
		}
	}
	if (SLT == 2)
	{
		printf(".d  Pattern: '%s'\n", x86_sled_pattern);
	}
	if (has_sparc_nops)
	{
		printf(SP_SPARC_NOP_START, sparc_nop_start);
		//OTHER SPARC RELATED INFO GOES HERE
	}
	if (Has_Opcode_Instructions)
	{
		SCinfo = SHC_Check_If_Known(buffer, sled_len);
		SCinfo++;

		if (x86_sled_len > FALSE)
		{
			x86_return_address = Find_Reversed_x86_Address(buffer);
			if (x86_return_address != -1)
				Impost_PutsF(0, SP_RETADDR_X86,
					     x86_return_address);
		}
		printf(SP_FIRST_INST, x86_sled_len,
		       (buffer[x86_sled_len] & 0xff));
	} else
	{
		if (!has_sparc_nops)
			Impost_PutsF(0, SP_NO_OPCODES);
		else
			has_sparc_nops = FALSE;
	}

	Detected_NOP_chr = FALSE;
	Has_Opcode_Instructions = FALSE;

	memset(Detected_sled_Type, 0, 100);

	return 0;
}

/*
 * Print recv() and send() messages to output, replace '\n' with '\\n'
 */
int
Impost_PrintIO(io_type, sfd, bsize, buffer)
	int             io_type;
	int             sfd;
	int             bsize;
	char           *buffer;
{
	int             i;
	char           *disp_type = (char *)malloc(28);

	switch (io_type)
	{
	case IO_TYPE_RECV:
		strcpy(disp_type, "recv");
		break;
	case IO_TYPE_SEND:
		strcpy(disp_type, "send");
		break;
	case IO_TYPE_PACKET:
		strcpy(disp_type, SNIFFER_DATA_SEG);
		break;
	default:
		return -1;
	}

	if (io_type == IO_TYPE_PACKET)
		Impost_PutsF(0, ".i %s: ", disp_type);
	else
		Impost_PutsF(0, "io %s(fd=%d,size=%d): ", disp_type,
			     sfd, bsize);

	for (i = 0; i < strlen(buffer); i++)
	{
		if (buffer[i] == '\n')
		{
			Impost_PutsF(1, "\\n");
			continue;
		}
		Impost_PutsF(1, "%c", buffer[i]);
	}
	Impost_PutsF(1, "\n");

	return 0;
}

/* Initial detection scan.  */
int
Initial_Scan(buffer, nl_len)
	char           *buffer;
	int             nl_len;
{
	int             Found_Opcode_Type;
	nop_info        found_nops = FALSE;

	has_sparc_nops = Locate_SPARC_Nops(buffer);
	if (!has_sparc_nops)
	{
		Has_Opcode_Instructions = SHC_Has_X86_Opcode(buffer);
		if (!Has_Opcode_Instructions)
		{
			//ADD MORE SPARC OPCODE DETECTION HERE
				if (Has_Opcode_Instructions || checking_messages)
				Found_Opcode_Type = OC_TYPE_SPARC;
		}
	}
	if (Has_Opcode_Instructions && !has_sparc_nops)
	{
		x86_sled_len = x86_sled(buffer);
		if (x86_sled_len > 10)
		{
			found_nops = TRUE;
			x86_sled_t = x86_sled_Type(buffer, x86_sled_len);
			memset(Detected_sled_Type, 0, 100);
			switch (x86_sled_t)
			{
			case X86_SLED_SINGLE:
				Detected_NOP_chr = (nop_t) buffer[0] & 0xff;
				SLT = X86_SLED_SINGLE;

				sprintf(Detected_sled_Type,
					X86_SLED_TYPE_1);
				break;

			case X86_SLED_PATTERN:
				SLT = X86_SLED_PATTERN;

				sprintf(Detected_sled_Type,
					X86_SLED_TYPE_2,
					x86_sled_pattern_size);
				break;

			case X86_SLED_RANDOM:
				SLT = X86_SLED_RANDOM;

				sprintf(Detected_sled_Type,
					X86_SLED_TYPE_3,
					x86_sled_t);
				break;
			default:
				SLT = 4;
				sprintf(Detected_sled_Type,
					X86_SLED_UNKNOWN);
				break;
			}
		}
	}
	return found_nops;
}

/*
 * Read from the currently "active" connection from our list of possible
 * connections.
 */
int
Impost_Receive(selected)
	int             selected;
{
	char           *buffer = (char *)malloc(config_opt[C_OPT_MAX_READ_SIZE].value);
	char           *temp = (char *)malloc(config_opt[C_OPT_MAX_READ_SIZE].value);
	int             nl_len = 0, i = 0, ret = 0, noprint = 0, found_nops = 0;
	nop_t           hex;

	if (buffer == FALSE || temp == FALSE)
	{
		Impost_PutsF(0, ERROR_MALLOC);
		exit(1);
	}
	memset(buffer, 0, config_opt[C_OPT_MAX_READ_SIZE].value);

	while ((ret = recv(Connections[selected], &buffer[i], 1, 0)) > 0)
	{
		nl_len++;
		if (buffer[i] == '\n' || buffer[i] == '\0' || buffer[i] == 0)
			break;
		if (nl_len == config_opt[C_OPT_MAX_READ_SIZE].value)
			break;
		i++;
	}

	if (nl_len == 0)
	{
		Impost_PutsF(0, IMPOST_LOST_CONN,
			     Impost_Get_TimeStamp(),
			     Client_ip[selected]);

		clear_Received_History(selected);
		close(Connections[selected]);
		Connections[selected] = FALSE;

		return 0;
	}
	/* Strip CR codes at EOL.  */
	if (buffer[nl_len - 2] == '\r')
		buffer[nl_len - 2] = '\0';
	else
		buffer[nl_len] = '\0';

	found_nops = Initial_Scan(buffer, nl_len);

	if (nl_len > config_opt[0].value || Has_Opcode_Instructions > 0)
	{
		Detected_Buffer(buffer, nl_len, x86_sled_len, 0,
				selected, x86_sled_len);
		if (!disable_capture)
		{
			Impost_PutsF(0, SP_SAVING);
			Impost_Capture(buffer, selected,
				       SERVER_CAPTURE, Client_ip[selected]);
		}
	} else
	{
		memset(temp, 0, config_opt[C_OPT_MAX_READ_SIZE].value);
		for (i = 0; i < strlen(buffer); i++)
		{
			if (buffer[i] == '\n')
				strcat(temp, "\\n");
			else
				sprintf(temp, "%s%c", temp, buffer[i]);
		}
		strncpy(User_Info[selected].Received_History[User_Info[selected].Hist_count],
		       temp, 256);
		User_Info[selected].Hist_count++;
	}

	for (i = 0; i < strlen(buffer) - 1; i++)
	{
		if (!isprint(buffer[i]) && buffer[i] != '\n' &&
		    buffer[i] != '\r')
		{
			noprint = 1;
			break;
		}
		noprint = 0;
	}

	if (!noprint)
		Impost_PrintIO(IO_TYPE_RECV, Connections[selected],
			       nl_len, buffer);
	else
	{
		if (noprint && nl_len > 1)
			Impost_Hexdump(buffer, selected);
	}

	if (Use_Script == 1 &&
	    ((nl_len < config_opt[0].value) || !found_nops))
	{
		if (Perl_On_Server_Read(buffer,
					Connections[selected]) == 11)
		{
			Impost_PutsF(0, IMPOST_SCRIPT_DISC,
				     Impost_Get_TimeStamp(),
				     Client_ip[selected]);
			Impost_PutsF(0, IMPOST_SCRIPT_DSD,
				     Connections[selected]);

			close(Connections[selected]);
			Connections[selected] = 0;
		}
	}
	if (buffer != NULL)
		free(buffer);
	buffer = NULL;

	return 0;
}

/* Return formatted time-stamp.  */
char           *
Impost_Get_TimeStamp()
{
	struct tm      *timeptr;
	time_t          tm;
	char           *ret = (char *)malloc(16);

	tm = time(NULL);
	timeptr = localtime(&tm);

	strftime(ret, 16, "%m/%d/%y %H:%M", timeptr);

	return ret;
}

/* Return time as (Hour:Minute).  */
char           *
Impost_Get_Time()
{
	struct tm      *timeptr;
	time_t          tm;
	char           *ret = (char *)malloc(11);

	tm = time(NULL);
	timeptr = localtime(&tm);

	strftime(ret, 11, "%H:%M", timeptr);
	return ret;
}

/* Shutdown Impost cleanly.  */
void
Impost_Signal_Shutdown(sign)
	int             sign;
{
	int             i;

	for (i = 0; i < 5; i++)
	{
		if (Connections[i] != FALSE)
		{
			close(Connections[i]);
			Impost_PutsF(1, IMPOST_CLOSING_CONN,
				     Impost_Get_TimeStamp(),
				     Connections[i], Client_ip[i]);
		}
	}

	if (Use_Script == TRUE)
	{
		Impost_PutsF(0, IMPOST_UNLOAD_SCRIPT);
		Perl_Unload_Script();
	}
	Impost_PutsF(0, "Exiting!\n");
	exit(0);
}

/* Main server loop.  */
int
Impost_Server_Loop()
{
	int             ret, i, connection_count;
	struct timeval  tv;

#ifdef HAVE_SIGNAL
	signal(SIGINT, Impost_Signal_Shutdown);
	signal(SIGTERM, Impost_Signal_Shutdown);
	signal(SIGKILL, Impost_Signal_Shutdown);
#endif				/* HAVE_SIGNAL */

	Impost_PutsF(0, IMPOST_WAITING);

	do
	{
		FD_ZERO(&Socket_List);
		FD_SET(Local_sock, &Socket_List);

		for (i = 0, connection_count = 0; i < 5; i++)
		{
			if (Connections[i] != 0)
			{
				connection_count++;
				FD_SET(Connections[i], &Socket_List);

				if (Connections[i] > Highest_Socket)
					Highest_Socket = Connections[i];
			}
		}

		tv.tv_sec = 1;
		tv.tv_usec = 0;

		if ((ret = select(Highest_Socket + 1,
				  &Socket_List, NULL, NULL, &tv)) < 0)
		{
			perror("select()");
			exit(1);
		}
		if (ret != 0)
		{
			if (FD_ISSET(Local_sock, &Socket_List))
				Impost_Accept_Connection();

			for (i = 0; i < 5; i++)
			{
				if (FD_ISSET(Connections[i],
					     &Socket_List))
					Impost_Receive(i);
			}
		}
	}
	while (1);
}

/* Print out current configuration setup.  */
int
Display_Variables()
{
	Impost_PutsF(0, "CFG %s = %d BYTES\n"
		     "CFG %s = %d (%s)\n"
		     "CFG %s = '%s'\n"
		     "CFG %s = %d\n"
		     "CFG %s = '%s'\n"
		     "CFG %s = '%s'\n",

		     config_opt[0].variable, config_opt[0].value,

		     config_opt[1].variable, config_opt[1].value,
		     config_opt[1].value ? "TRUE" : "FALSE",
		     config_opt[2].variable, config_opt[2].option,

		     config_opt[3].variable, config_opt[3].value,

		     config_opt[4].variable, config_opt[4].option,
		     config_opt[5].variable, config_opt[5].option);

	return 0;
}

/* Handle the new connection.  */
int
Impost_Accept_Connection()
{
	int             i, new_socket, opts;
	int             addr_size = sizeof(struct sockaddr_in);
	struct sockaddr_in new_client;

	new_socket = accept(Local_sock, (struct sockaddr *) & new_client,
			    (socklen_t *) & addr_size);
	if (new_socket == -1)
	{
		perror("accept()");
		exit(1);
	}
#ifdef HAVE_FCNTL
	opts = fcntl(new_socket, F_GETFL);
	if (opts < 0)
	{
		perror("fcntl()");
		exit(1);
	}
	opts = (opts | O_NONBLOCK);
	if (fcntl(new_socket, F_SETFL, opts) < 0)
	{
		perror("fcntl()");
		exit(1);
	}
#endif				/* HAVE_FCNTL */

	for (i = 0; i < 5; i++)
	{
		if (Connections[i] == FALSE)
		{
			Impost_PutsF(0, IMPOST_ACCEPTED, Impost_Get_TimeStamp(),
				     inet_ntoa(new_client.sin_addr));

			strcpy(Client_ip[i],
			       (char *)inet_ntoa(new_client.sin_addr));

			if (Use_Script == TRUE)
			{
				Perl_On_Server_Accept(Client_ip[i], new_socket);
			}
			Connections[i] = new_socket;
			return 0;
		}
	}

	return -1;
}

/*
 * Create socket to bind server to; set SO_REUSEADDR option and enable
 * NON-BLOCKING.
 */
int
Impost_Create_Server()
{
	int             ru_addr = 1, opts;
	struct sockaddr_in sin_local;

	if (Display_conf_setup)
		Display_Variables();

	Local_sock = socket(AF_INET, SOCK_STREAM, 0);
	if (Local_sock < FALSE)
	{
		perror("socket()");
		exit(1);
	}
#ifdef HAVE_SETSOCKOPT
	setsockopt(Local_sock, SOL_SOCKET, SO_REUSEADDR,
		   &ru_addr, sizeof(ru_addr));
#endif				/* HAVE_SETSOCKOPT */

#ifdef HAVE_FCNTL
	if ((opts = fcntl(Local_sock, F_GETFL)) < 0)
	{
		perror("fcntl()");
		exit(1);
	}
	opts = (opts | O_NONBLOCK);
	if (fcntl(Local_sock, F_SETFL, opts) < 0)
	{
		perror("fcntl()");
		exit(1);
	}
#endif				/* HAVE_FCNTL */

	sin_local.sin_family = AF_INET;
	sin_local.sin_port = htons(Server_port);
	sin_local.sin_addr.s_addr = INADDR_ANY;

	if (bind(Local_sock, (struct sockaddr *) & sin_local,
		 sizeof(sin_local)) < FALSE)
	{
		perror("bind()");

		close(Local_sock);
		exit(1);
	}
	if (listen(Local_sock, 5) < FALSE)
	{
		perror("listen()");

		/* You suck.  */
		close(Local_sock);
		exit(1);
	}
	Highest_Socket = Local_sock;
	Impost_PutsF(1, IMPOST_BINDED_PORT,
		     Impost_Get_TimeStamp(), Server_port);

	return 0;
}

/* EOF */
