/* messages.h - main output messages

   Written by ziplock

   Comments: sickbeatz@hotmail.com
   IRC: #b4b0 on EFNet
 
   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.  */

/* Shellcode definition file errors.  */
#define	SHCDEFS_BADSYNTAX	_gt("!! bad syntax in shellcode definitions, ignoring (line %d)\n")
#define	SHCDEFS_ERROR_OPEN	_gt("!! failed to open shellcode definitions file, please fix your configuration\n")

/* Set option messages.  */
#define	OPTION_CONFIG		_gt(".s using `%s' as the configuration script for this session\n")

/* Error messages.  */
#define	ERROR_CONFIG_NOTFOUND	_gt("!! failed to load config, file not found: %s\n")
#define	ERROR_SCRIPT_NOTFOUND	_gt("!! failed to load perl script, file not found: %s\n")
#define	ERROR_SCRIPT_FAIL	_gt("!! failed to execute perl script, exiting!\n")
#define	ERROR_MALLOC		_gt("!! malloc() failed - virtual memory is exhausted\n")
#define ERROR_MTS_TOO_SMALL	_gt("!! configuration variable `MSG_TRIGGER_SIZE' is too small\n")
#define ERROR_NOCAPDIR          _gt("!! CAPTURE DIRECTORY NOT FOUND - ATTEMPTING TO CREATE..\n")
#define ERROR_NO_MKDIR          _gt("!! YOUR SYSTEM DOES NOT SUPPORT mkdir()\n")
#define ERROR_NO_MKDIR2         _gt("!! YOU'LL NEED TO MANUALLY CREATE THE FOLLOWING DIRECTORY:\n")
#define ERROR_USING_DEFAULTS    _gt("!! IMPOST WILL USE THE DEFAULT OPTIONS (A LIST WILL BE DISPLAYED)\n")

#define CREATED_DIRECTORY       _gt("!! Created directory: '%s'\n")

/* Misc. Impost output messages.  */
#define IMPOST_CLOSING_CONN     _gt("%s closing (%d) connection with %s\n")
#define IMPOST_CAPTURE_FILE     _gt(" - Capture file: %s\n")
#define	IMPOST_LOAD_SCRIPT	_gt(".s loading script: `%s'\n")
#define IMPOST_UNLOAD_SCRIPT	_gt("shutdown: unloading Perl script...\n")
#define	IMPOST_BINDED_PORT	_gt("%s SERVER STARTED, BINDED SOCKET ON PORT %d\n")
#define IMPOST_INIT_SNIFFER     _gt("%s INITIALIZING PACKET SNIFFER\n")
#define IMPOST_WAITING		_gt(".i Waiting for connections...\n")
#define IMPOST_LOST_CONN	_gt("%s Lost connection with %s\n")
#define	IMPOST_SCRIPT_DISC	_gt("%s Script ordered disconnection with %s\n")
#define	IMPOST_SCRIPT_DSD	_gt("               Socket descriptor: %d\n")
#define IMPOST_EXITING		_gt("Exiting...\n")
#define IMPOST_ACCEPTED		_gt("%s Accepted connection from %s\n")
#define IMPOST_READ		_gt("io recv(sock=%d,size=%d): %s\n")
#define	IMPOST_SEND		_gt("io send(sock=%d,size=%d): %s\n")
#define IMPOST_HEXDUMP1		_gt("hd%d Hex: %s")
#define	IMPOST_HEXDUMP2		_gt(" Ascii %s\n")
#define	IMPOST_HEXDUMP3		_gt("hd%d Hex: %s Ascii %s\n")
#define IMPOST_HEXDUMP_REPEAT	_gt("hd%d last line repeated %d times\n")

/* Operation code checking messages.  */
#define CHECKING_X86_SLED_T     _gt(".c Checking x86 `NOP sled' type.\n")
#define CHECKING_X86_OPCODES    _gt(".c Checking for X86 operation codes: ")
#define CHECKING_SPARC_OPCODES  _gt(".c Checking for SPARC operation codes: ")
#define CHECKING_FOUND          _gt("yes\n")
#define CHECKING_NOTFOUND       _gt("no\n")

#define SNIFFER_DATA_SEG        _gt("DATA SEGMENT")

/* SP_* Detection/Misc. detection/guess output.  */
#define SP_DETECT		_gt(".d Detected suspicious buffer (%d bytes)\n")
#define SP_NO_OPCODES           _gt(".d Zero `known' operation codes were found\n")
#define SP_X86_NOP_COUNT	_gt(".i  Generic x86 NOP code (Intel 0x90) used for padding (%d times)\n")
#define SP_SLED_TYPE            _gt(".i Style of `NOP' padding (aka `sled'): %s\n")
#define SP_OTHER_CHAR_NOP	_gt(" - ^ single no operation (0x%x:'%c') repeated %d times\n")
#define SP_SAVING		_gt(".i Saving received message history and suspicious buffer\n")
#define SP_SHELLCODE_FOUND	_gt(".c  Shellcode match: %s\n")
#define SP_FIRST_INST		_gt(".g  First instruction code position: %d, hexidecimal: \\x%x\n")
#define SP_POS_ADMMUTATE	_gt(".g  Possibility: `ADMmutate' polymorphing\n")
#define SP_RETADDR_X86          _gt(".g  Possible x86 return address = `0x%lx' (last 4 non-NOP bytes)\n")
#define SP_SPARC_NOP_START      _gt(".i SPARC `NOP' start: byte %d\n")
#define SP_SPARC_NOP_FIND       _gt(".i Found `0x%.2x%.2x%.2x%.2x' (SPARC no operation)\n")

#define X86_SLED_TYPE_1         _gt("1 byte (repeating)")
#define X86_SLED_TYPE_2         _gt("repeating %d byte pattern")
#define X86_SLED_TYPE_3         _gt("random")
#define X86_SLED_UNKNOWN        _gt("unknown")

#define IMPOST_BANNER		"Impost(er) Version %s (%s) by ziplock\n"

/* EOF */

