/* shextra.h - extra shellcode stuff

   Written by ziplock

   Comments: sickbeatz@hotmail.com
   IRC: #b4b0 on EFNet

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA.  */

/* Operation code pointers  */
#define	CODE_XOR	0x01
#define	CODE_MOVB	0x02
#define	CODE_MOVW	0x03
#define	CODE_MOV	0x04
#define	CODE_INC	0x05
#define	CODE_ADD	0x06
#define	CODE_SUB	0x07
#define	CODE_LEAL	0x08
#define	CODE_INT	0x09
#define	CODE_PUSH	0x10
#define	CODE_JMP	0x11
#define	CODE_CALL	0x12
#define	CODE_POP	0x13
#define	CODE_DEC	0x14
#define CODE_LOOP       0x15
#define CODE_CMP	0x16
#define CODE_JE		0x17
#define	CODE_POPL	0x18
#define	CODE_MOVL	0x19
#define CODE_SUBL       0x20
#define CODE_AND        0x21
#define CODE_TA         0x22

/* Number of opcodes defined  */
#define X86_OPCODES_L   51
#define SPARC_OPCODES_L 4

/* Common SPARC opcodes  */
struct common_opcode sparc_common[SPARC_OPCODES_L] = {
    { "\x82\x10\x20\xca", "mov 0xca, %g1",  0x04, 4, "\\x82\\x10\\x20\\xca" },
    { "\x92\x1a\x40\x09", "xor %o1,%o1,%o1",0x01, 4, "\\x92\\x1a\\x40\\x09" },
    { "\x90\x0a\x40\x09", "and %o1,%o1,%o0",0x21, 4, "\\x90\\x0a\\x40\\x09" },
    { "\x91\xd0\x20\x08", "ta 8",           0x22, 4, "\\x91\\xd0\\x20\\x08" },
};

/* Common x86 (Intel) opcodes  */
struct common_opcode x86_common[X86_OPCODES_L] = {
    { "\xeb\x01",             "jmp   call",          0x11, 2, "\\xeb\\x01" },
    { "\xeb\x2a",             "jmp   0x2a",          0x11, 2, "\\xeb\\x2a" },
    { "\xeb\x26",             "jmp   0x26",          0x11, 2, "\\xeb\\x26" },
    { "\xeb\x1b",             "jmp   0x1b",          0x11, 2, "\\xeb\\x1b" },
    { "\xeb\x1f",             "jmp   0x1f",          0x11, 2, "\\xeb\\x1f" },
    { "\xe8\x01\xff\xff\xff", "call  pop",           0x12, 5, "\\xe8\\x01\\xff\\xff\\xff" },
    { "\x5e",                 "popl  %esu",          0x18, 1, "\\5e" },
    { "\xcd\x80",             "int   $0x80",         0x09, 2, "\\xcd\\x80" },
    { "\xe2\xfb",             "loop  xor",           0x15, 2, "\\xe2\\xfb" },
    { "\x39\xc2",             "cmp   %eax,%edx",     0x16, 2, "\\x39\\xc2" },
    { "\x75\x01",             "je",                  0x17, 2, "\\x75\\x01" },
    { "\x88\x56\x01",         "movb  %dl,0x1(%esi)", 0x02, 3, "\\x88\\x56\\x01" },
    { "\x88\x46\x01",         "movb  %al,0x1(%esi)", 0x02, 3, "\\x88\\x46\\x01" },
    { "\x89\x76\x01",         "mov   %esi,0x1(%esi)",0x04, 3, "\\x89\\x76\\x01" },
    { "\x89\x46\x01",         "mov   %eax,0x1(%esi)",0x04, 3, "\\x89\\x46\\x01" },
    { "\x89\x5e\x01",         "mov   %ebx,0x1(%esi)",0x04, 3, "\\x89\\x5e\\x01" },
    { "\x89\xe1",             "movl  %esp,%ecx",     0x19, 2, "\\x89\\xe1" },
    { "\x89\xc3",             "mov   %eax,%ebx",     0x04, 2, "\\x89\\xc3" },
    { "\x89\xc1",             "mov   %eax,%ecx",     0x04, 2, "\\x89\\xc1" },
    { "\x89\xc8",             "mov   %ecx,%eax",     0x04, 2, "\\x89\\xc8" },
    { "\x89\xf3",             "mov   %esi,%ebx",     0x04, 2, "\\x89\\xf3" },
    { "\x89\xf1",             "mov   %esi,%ecx",     0x04, 2, "\\x89\\xf1" },
    { "\x89\xfb",             "mov   %edi,%ebx",     0x04, 2, "\\x89\\xfb" },
    { "\xb0\x01",             "movb  $0x1,%al",      0x02, 2, "\\xb0\\x01" },
    { "\xb1\x01",             "movb  $0x1,%cl",      0x02, 2, "\\xb1\\x01" },
    { "\xb2\x01",             "movb  $0x1,%dl",      0x02, 2, "\\xb2\\x01" },
    { "\xb5\x01",             "movb  $0x1,%ch",      0x02, 2, "\\xb5\\x01" },
    { "\xb0\xe1",             "movb  $0xb,%al",      0x02, 2, "\\xb0\\xe1" },
    { "\xb1\xe1",             "movb  $0xb,%cl",      0x02, 2, "\\xb1\\xe1" },
    { "\xb2\xe1",             "movb  $0xb,%dl",      0x02, 2, "\\xb2\\xe1" },
    { "\xb5\xe1",             "movb  $0xb,%ch",      0x02, 2, "\\xb5\\xe1" },
    { "\x66\xb9\x01\x01",     "movw  $0x101,%cx",    0x03, 4, "\\x66\\xb9\\x01\\x01" },
    { "\x31\xc0",             "xor   %eax,%eax",     0x01, 2, "\\x31\\xc0" },
    { "\x31\xdb",             "xor   %ebx,%ebx",     0x01, 2, "\\x31\\xdb" },
    { "\x31\xc9",             "xor   %ecx,%ecx",     0x01, 2, "\\x31\\xc9" },
    { "\x31\xd2",             "xor   %edx,%edx",     0x01, 2, "\\x31\\xd2" },
    { "\x30\x03",             "xor   %al,(%ebx)",    0x01, 2, "\\x30\\x03" },
    { "\x40",                 "inc   %eax",          0x05, 1, "\\x40" },
    { "\x43",                 "inc   %ebx",          0x05, 1, "\\x41" }, 
    { "\x80\xc3\x01",         "add   $0x1,%bl",      0x06, 3, "\\x80\\xc3\\x01" },
    { "\x80\xc3\xe1",         "add   $0xb,%bl",      0x06, 3, "\\x80\\xc3\\xe1" },
    { "\x01\xce",             "add   %ecx,%esi",     0x06, 2, "\\x01\\xce" },
    { "\x83\xeb\x01",         "sub   $0x1,$ebx",     0x07, 3, "\\x83\\xeb\\x01" },
    { "\x29\xc0",             "subl  %eax,%eax",     0x20, 2, "\\x29\\xc0" },
    { "\x29\xdb",             "subl  %ebx,%ebx",     0x20, 2, "\\x29\\xdb" },
    { "\x29\xc9",             "subl  %ecx,%ecx",     0x20, 2, "\\x29\\xc9" },
    { "\x29\xd2",             "subl  %edx,%edx",     0x20, 2, "\\x29\\xd2" },
    { "\x50",                 "push  %eax",          0x10, 1, "\\x50" },
    { "\x51",                 "push  %ecx",          0x10, 1, "\\x51" },
    { "\x52",                 "push  %edx",          0x10, 1, "\\x52" },
    { "\x56",                 "push  %esi",          0x10, 1, "\\x56" }
};


/* The following was taken from ADMmutate-0.8.4:  */
#define IA32_JUNKS 78

struct junks {
   char *code;          /* the operation code */
   size_t len;          /* length of code */
   int noppad;          /* can we use it for NOP pad? */
   int morph;           /* can we use it for morph pad? */
   int upper;           /* can we use through toupper()? */
   int lower;           /* can we use through tolower()? */
   int dyn;             /* is the instruction dynamic? */
   int dynint;          /* where is the dynamic byte? */
   int weight;          /* weight of this code to appear in output 1 == low, > 1 is higher :) */
};

struct junks intel_njunk[IA32_JUNKS] = {
/* these may be dangerious depending on your sploit */
   { "\x50",1,1,0,1,0,0,0,1 },         /* push %eax  "P" */
   { "\x51",1,1,0,1,0,0,0,1 },         /* push %ecx  "Q" */
   { "\x52",1,1,0,1,0,0,0,1 },         /* push %edx  "R" */
   { "\x53",1,1,0,1,0,0,0,1 },         /* push %ebx  "S" */
   { "\x54",1,1,0,1,0,0,0,1 },         /* push %dsp  "T" */
   { "\x55",1,1,0,1,0,0,0,1 },         /* push %ebp  "U" */
   { "\x56",1,1,0,1,0,0,0,1 },         /* push %esi  "V" */
   { "\x57",1,1,0,1,0,0,0,1 },         /* push %edi  "W" */
   { "\x58",1,1,0,1,0,0,0,1 },         /* pop %eax   "X" */
   { "\x59",1,1,0,1,0,0,0,1 },         /* pop %ecx   "Y" */
   { "\x5a",1,1,0,1,0,0,0,1 },         /* pop %edx   "Z" */
   { "\x5b",1,1,0,1,1,0,0,1 },         /* pop %ebx   "[" */
   { "\x5d",1,1,0,1,1,0,0,1 },         /* pop %ebp   "]" */
   { "\x5e",1,1,0,1,1,0,0,1 },         /* pop %esi   "^" */
   { "\x5f",1,1,0,1,1,0,0,1 },         /* pop %edi   "_" */
   { "\x60",1,1,0,1,1,0,0,1 },         /* pusha      "`" */
   { "\x9b",1,1,1,1,1,0,0,1 },         /* fwait          */
   { "\x9c",1,1,1,1,1,0,0,1 },         /* pushf          */
   { "\x9e",1,1,1,1,1,0,0,1 },         /* safh           */
/* dangerious opcodes section over */
   { "\x99",1,1,1,1,1,0,0,1 },         /* cltd           */
   { "\x96",1,1,0,1,1,0,0,1 },         /* xchg %eax,%esi */
   { "\x97",1,1,0,1,1,0,0,1 },         /* xchg %eax,%edi */
   { "\x95",1,1,0,1,1,0,0,1 },         /* xchg %eax,%ebp */
   { "\x93",1,1,0,1,1,0,0,1 },         /* xchg %eax,%ebx */
   { "\x91",1,1,0,1,1,0,0,1 },         /* xchg %eax,%ecx */
   { "\x90",1,0,1,1,1,0,0,1 },         /* regular NOP    */
   { "\xc1\xe8\x42",3,0,1,1,1,1,2,1 }, /* shr N,%eax     */
   { "\x4d",1,1,0,1,0,0,0,1 },         /* dec %ebp,  "M" */
   { "\x6b\xc0\x42",3,0,1,1,1,1,2,1 }, /* imul N,%eax    */
   { "\x48",1,1,1,1,0,0,0,1 },         /* dec %eax,  "H" */
   { "\x33\xc0",2,0,1,1,1,0,0,1 },     /* xor %eax,%eax  */
   { "\x47",1,1,1,1,0,0,0,1 },         /* inc %edi   "G" */
   { "\x4f",1,1,1,1,0,0,0,1 },         /* dec %edi   "O" */
   { "\x40",1,1,1,1,1,0,0,1 },         /* inc %eax   "@" */
   { "\x8c\xc0",2,0,1,1,1,0,0,1 },     /* mov %es,%eax   */
   { "\x41",1,1,0,1,0,0,0,1 },         /* inc %ecx   "A" */
   { "\x37",1,1,1,1,1,0,0,1 },         /* aaa        "7" */
   { "\x3f",1,1,1,1,1,0,0,1 },         /* aas        "?" */
   { "\x97",1,1,1,1,1,0,0,1 },         /* xchg %eax,%edi */
   { "\x46",1,1,0,1,0,0,0,1 },         /* inc %esi   "F" */
   { "\x4e",1,1,0,1,0,0,0,1 },         /* dec %esi   "N" */
   { "\xf8",1,1,1,1,1,0,0,1 },         /* clc            */
   { "\x92",1,1,1,1,1,0,0,1 },         /* xchg %eax,%edx */
   { "\xfc",1,1,1,1,1,0,0,1 },         /* cld            */
   { "\x87\xdb",2,0,1,1,1,0,0,1 },     /* xchg %ebx,%ebx */
   { "\x98",1,1,1,1,1,0,0,1 },         /* cwtl           */
   { "\x27",1,1,1,1,1,0,0,1 },         /* daa        "'" */
   { "\x87\xc9",2,0,1,1,1,0,0,1 },     /* xchg %ecx,%ecx */
   { "\x2f",1,1,1,1,1,0,0,1 },         /* das        "/" */
   { "\x9f",1,1,1,1,1,0,0,1 },         /* lahf           */
   { "\x87\xd2",2,0,1,1,1,0,0,1 },     /* xchg %edx,%edx */
   { "\xf9",1,1,1,1,1,0,0,1 },         /* stc            */
   { "\x83\xf0\x42",3,0,1,1,1,1,2,1 }, /* xor N,%eax     */
   { "\x4a",1,1,0,1,0,0,0,1 },         /* dec %edx   "J" */
   { "\x8c\xe0",2,0,1,1,1,0,0,1 },     /* mov %fs,%eax   */
   { "\x44",1,1,0,1,0,0,0,1 },         /* inc %esp   "D" */
   { "\xc1\xc0\x42",3,0,1,1,1,1,2,1 }, /* rol N,%eax     */
   { "\x42",1,1,0,1,0,0,0,1 },         /* inc %edx   "B" */
   { "\x83\xfb\x42",3,0,0,1,1,1,2,1 }, /* cmp N,%ebx     */
   { "\x85\xc0",2,0,1,1,1,0,0,1 },     /* test %eax,%eax */
   { "\xc1\xc8\x42",3,0,1,1,1,1,2,1 }, /* ror N,%eax     */
   { "\x43",1,1,0,1,0,0,0,1 },         /* inc %ebx   "C" */
   { "\x83\xc8\x42",3,0,1,1,1,1,2,1 }, /* or  N,%eax     */
   { "\x49",1,1,0,1,0,0,0,1 },         /* dec %ecx   "I" */
   { "\x83\xe8\x42",3,0,1,1,1,1,2,1 }, /* sub N,%eax     */
   { "\x4b",1,1,0,1,0,0,0,1 },         /* dec %ebx   "K" */
   { "\x83\xfa\x42",3,0,0,1,1,1,2,1 }, /* cmp N,%edx     */
   { "\xf7\xd0",2,0,1,1,1,0,0,1 },     /* not %eax       */
   { "\x83\xf9\x42",3,0,0,1,1,1,2,1 }, /* cmp N,%ecx     */
   { "\x8c\xe8",2,0,1,1,1,0,0,1 },     /* mov %gs,%eax   */
   { "\xf5",1,1,1,1,1,0,0,1 },         /* cmc            */
   { "\x83\xe0\x42",3,0,1,1,1,1,2,1 }, /* and N,%eax     */
   { "\xb0\x42",2,0,1,1,1,1,1,1 },     /* mov N,%eax     */
   { "\x45",1,1,0,1,0,0,0,1 },         /* inc %ebp   "E" */
   { "\x83\xf8\x42",3,0,1,1,1,1,2,1 }, /* cmp N,%eax     */
   { "\x4c",1,1,0,1,0,0,0,1 },         /* dec %esp   "L" */
   { "\x83\xc0\x42",3,0,1,1,1,1,2,1 }  /* add N,%eax, N (\x42) will be dynamically loaded from good_keys (aka. list of char that are allowd) */
};

/* EOF */

